# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListAppSkillRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.app_id: Optional[str] = None

    @staticmethod
    def builder() -> "ListAppSkillRequestBuilder":
        return ListAppSkillRequestBuilder()


class ListAppSkillRequestBuilder(object):

    def __init__(self) -> None:
        list_app_skill_request = ListAppSkillRequest()
        list_app_skill_request.http_method = HttpMethod.GET
        list_app_skill_request.uri = "/open-apis/aily/v1/apps/:app_id/skills"
        list_app_skill_request.token_types = {AccessTokenType.USER, AccessTokenType.TENANT}
        self._list_app_skill_request: ListAppSkillRequest = list_app_skill_request

    def page_size(self, page_size: int) -> "ListAppSkillRequestBuilder":
        self._list_app_skill_request.page_size = page_size
        self._list_app_skill_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListAppSkillRequestBuilder":
        self._list_app_skill_request.page_token = page_token
        self._list_app_skill_request.add_query("page_token", page_token)
        return self

    def app_id(self, app_id: str) -> "ListAppSkillRequestBuilder":
        self._list_app_skill_request.app_id = app_id
        self._list_app_skill_request.paths["app_id"] = str(app_id)
        return self

    def build(self) -> ListAppSkillRequest:
        return self._list_app_skill_request
