# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.get_app_skill_request import GetAppSkillRequest
from ..model.get_app_skill_response import GetAppSkillResponse
from ..model.list_app_skill_request import ListAppSkillRequest
from ..model.list_app_skill_response import ListAppSkillResponse
from ..model.start_app_skill_request import StartAppSkillRequest
from ..model.start_app_skill_response import StartAppSkillResponse


class AppSkill(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def get(self, request: GetAppSkillRequest, option: Optional[RequestOption] = None) -> GetAppSkillResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetAppSkillResponse = JSON.unmarshal(str(resp.content, UTF_8), GetAppSkillResponse)
        response.raw = resp

        return response

    async def aget(self, request: GetAppSkillRequest, option: Optional[RequestOption] = None) -> GetAppSkillResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: GetAppSkillResponse = JSON.unmarshal(str(resp.content, UTF_8), GetAppSkillResponse)
        response.raw = resp

        return response

    def list(self, request: ListAppSkillRequest, option: Optional[RequestOption] = None) -> ListAppSkillResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListAppSkillResponse = JSON.unmarshal(str(resp.content, UTF_8), ListAppSkillResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListAppSkillRequest, option: Optional[RequestOption] = None) -> ListAppSkillResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListAppSkillResponse = JSON.unmarshal(str(resp.content, UTF_8), ListAppSkillResponse)
        response.raw = resp

        return response

    def start(self, request: StartAppSkillRequest, option: Optional[RequestOption] = None) -> StartAppSkillResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: StartAppSkillResponse = JSON.unmarshal(str(resp.content, UTF_8), StartAppSkillResponse)
        response.raw = resp

        return response

    async def astart(self, request: StartAppSkillRequest,
                     option: Optional[RequestOption] = None) -> StartAppSkillResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: StartAppSkillResponse = JSON.unmarshal(str(resp.content, UTF_8), StartAppSkillResponse)
        response.raw = resp

        return response
