# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .job_grade_create import JobGradeCreate


class CreateJobGradeRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.client_token: Optional[str] = None
        self.request_body: Optional[JobGradeCreate] = None

    @staticmethod
    def builder() -> "CreateJobGradeRequestBuilder":
        return CreateJobGradeRequestBuilder()


class CreateJobGradeRequestBuilder(object):

    def __init__(self) -> None:
        create_job_grade_request = CreateJobGradeRequest()
        create_job_grade_request.http_method = HttpMethod.POST
        create_job_grade_request.uri = "/open-apis/corehr/v2/job_grades"
        create_job_grade_request.token_types = {AccessTokenType.TENANT}
        self._create_job_grade_request: CreateJobGradeRequest = create_job_grade_request

    def client_token(self, client_token: str) -> "CreateJobGradeRequestBuilder":
        self._create_job_grade_request.client_token = client_token
        self._create_job_grade_request.add_query("client_token", client_token)
        return self

    def request_body(self, request_body: JobGradeCreate) -> "CreateJobGradeRequestBuilder":
        self._create_job_grade_request.request_body = request_body
        self._create_job_grade_request.body = request_body
        return self

    def build(self) -> CreateJobGradeRequest:
        return self._create_job_grade_request
