# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .search_basic_info_time_zone_request_body import SearchBasicInfoTimeZoneRequestBody


class SearchBasicInfoTimeZoneRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.request_body: Optional[SearchBasicInfoTimeZoneRequestBody] = None

    @staticmethod
    def builder() -> "SearchBasicInfoTimeZoneRequestBuilder":
        return SearchBasicInfoTimeZoneRequestBuilder()


class SearchBasicInfoTimeZoneRequestBuilder(object):

    def __init__(self) -> None:
        search_basic_info_time_zone_request = SearchBasicInfoTimeZoneRequest()
        search_basic_info_time_zone_request.http_method = HttpMethod.POST
        search_basic_info_time_zone_request.uri = "/open-apis/corehr/v2/basic_info/time_zones/search"
        search_basic_info_time_zone_request.token_types = {AccessTokenType.TENANT}
        self._search_basic_info_time_zone_request: SearchBasicInfoTimeZoneRequest = search_basic_info_time_zone_request

    def page_size(self, page_size: int) -> "SearchBasicInfoTimeZoneRequestBuilder":
        self._search_basic_info_time_zone_request.page_size = page_size
        self._search_basic_info_time_zone_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "SearchBasicInfoTimeZoneRequestBuilder":
        self._search_basic_info_time_zone_request.page_token = page_token
        self._search_basic_info_time_zone_request.add_query("page_token", page_token)
        return self

    def request_body(self, request_body: SearchBasicInfoTimeZoneRequestBody) -> "SearchBasicInfoTimeZoneRequestBuilder":
        self._search_basic_info_time_zone_request.request_body = request_body
        self._search_basic_info_time_zone_request.body = request_body
        return self

    def build(self) -> SearchBasicInfoTimeZoneRequest:
        return self._search_basic_info_time_zone_request
