# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .process_revoke_and_withdraw import ProcessRevokeAndWithdraw


class UpdateProcessRevokeRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.process_id: Optional[str] = None
        self.request_body: Optional[ProcessRevokeAndWithdraw] = None

    @staticmethod
    def builder() -> "UpdateProcessRevokeRequestBuilder":
        return UpdateProcessRevokeRequestBuilder()


class UpdateProcessRevokeRequestBuilder(object):

    def __init__(self) -> None:
        update_process_revoke_request = UpdateProcessRevokeRequest()
        update_process_revoke_request.http_method = HttpMethod.PUT
        update_process_revoke_request.uri = "/open-apis/corehr/v2/process_revoke/:process_id"
        update_process_revoke_request.token_types = {AccessTokenType.TENANT}
        self._update_process_revoke_request: UpdateProcessRevokeRequest = update_process_revoke_request

    def user_id_type(self, user_id_type: str) -> "UpdateProcessRevokeRequestBuilder":
        self._update_process_revoke_request.user_id_type = user_id_type
        self._update_process_revoke_request.add_query("user_id_type", user_id_type)
        return self

    def process_id(self, process_id: str) -> "UpdateProcessRevokeRequestBuilder":
        self._update_process_revoke_request.process_id = process_id
        self._update_process_revoke_request.paths["process_id"] = str(process_id)
        return self

    def request_body(self, request_body: ProcessRevokeAndWithdraw) -> "UpdateProcessRevokeRequestBuilder":
        self._update_process_revoke_request.request_body = request_body
        self._update_process_revoke_request.body = request_body
        return self

    def build(self) -> UpdateProcessRevokeRequest:
        return self._update_process_revoke_request
