# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .process_transfer import ProcessTransfer


class UpdateProcessTransferRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.process_id: Optional[str] = None
        self.request_body: Optional[ProcessTransfer] = None

    @staticmethod
    def builder() -> "UpdateProcessTransferRequestBuilder":
        return UpdateProcessTransferRequestBuilder()


class UpdateProcessTransferRequestBuilder(object):

    def __init__(self) -> None:
        update_process_transfer_request = UpdateProcessTransferRequest()
        update_process_transfer_request.http_method = HttpMethod.PUT
        update_process_transfer_request.uri = "/open-apis/corehr/v2/processes/:process_id/transfer"
        update_process_transfer_request.token_types = {AccessTokenType.TENANT}
        self._update_process_transfer_request: UpdateProcessTransferRequest = update_process_transfer_request

    def user_id_type(self, user_id_type: str) -> "UpdateProcessTransferRequestBuilder":
        self._update_process_transfer_request.user_id_type = user_id_type
        self._update_process_transfer_request.add_query("user_id_type", user_id_type)
        return self

    def process_id(self, process_id: str) -> "UpdateProcessTransferRequestBuilder":
        self._update_process_transfer_request.process_id = process_id
        self._update_process_transfer_request.paths["process_id"] = str(process_id)
        return self

    def request_body(self, request_body: ProcessTransfer) -> "UpdateProcessTransferRequestBuilder":
        self._update_process_transfer_request.request_body = request_body
        self._update_process_transfer_request.body = request_body
        return self

    def build(self) -> UpdateProcessTransferRequest:
        return self._update_process_transfer_request
