# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.create_location_address_request import CreateLocationAddressRequest
from ..model.create_location_address_response import CreateLocationAddressResponse
from ..model.delete_location_address_request import DeleteLocationAddressRequest
from ..model.delete_location_address_response import DeleteLocationAddressResponse
from ..model.patch_location_address_request import PatchLocationAddressRequest
from ..model.patch_location_address_response import PatchLocationAddressResponse


class LocationAddress(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def create(self, request: CreateLocationAddressRequest,
               option: Optional[RequestOption] = None) -> CreateLocationAddressResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateLocationAddressResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 CreateLocationAddressResponse)
        response.raw = resp

        return response

    async def acreate(self, request: CreateLocationAddressRequest,
                      option: Optional[RequestOption] = None) -> CreateLocationAddressResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: CreateLocationAddressResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 CreateLocationAddressResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteLocationAddressRequest,
               option: Optional[RequestOption] = None) -> DeleteLocationAddressResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteLocationAddressResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 DeleteLocationAddressResponse)
        response.raw = resp

        return response

    async def adelete(self, request: DeleteLocationAddressRequest,
                      option: Optional[RequestOption] = None) -> DeleteLocationAddressResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: DeleteLocationAddressResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 DeleteLocationAddressResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchLocationAddressRequest,
              option: Optional[RequestOption] = None) -> PatchLocationAddressResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchLocationAddressResponse = JSON.unmarshal(str(resp.content, UTF_8), PatchLocationAddressResponse)
        response.raw = resp

        return response

    async def apatch(self, request: PatchLocationAddressRequest,
                     option: Optional[RequestOption] = None) -> PatchLocationAddressResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: PatchLocationAddressResponse = JSON.unmarshal(str(resp.content, UTF_8), PatchLocationAddressResponse)
        response.raw = resp

        return response
