# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class GetChatAnnouncementBlockChildrenRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.revision_id: Optional[int] = None
        self.page_token: Optional[str] = None
        self.page_size: Optional[int] = None
        self.user_id_type: Optional[str] = None
        self.chat_id: Optional[str] = None
        self.block_id: Optional[str] = None

    @staticmethod
    def builder() -> "GetChatAnnouncementBlockChildrenRequestBuilder":
        return GetChatAnnouncementBlockChildrenRequestBuilder()


class GetChatAnnouncementBlockChildrenRequestBuilder(object):

    def __init__(self) -> None:
        get_chat_announcement_block_children_request = GetChatAnnouncementBlockChildrenRequest()
        get_chat_announcement_block_children_request.http_method = HttpMethod.GET
        get_chat_announcement_block_children_request.uri = "/open-apis/docx/v1/chats/:chat_id/announcement/blocks/:block_id/children"
        get_chat_announcement_block_children_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._get_chat_announcement_block_children_request: GetChatAnnouncementBlockChildrenRequest = get_chat_announcement_block_children_request

    def revision_id(self, revision_id: int) -> "GetChatAnnouncementBlockChildrenRequestBuilder":
        self._get_chat_announcement_block_children_request.revision_id = revision_id
        self._get_chat_announcement_block_children_request.add_query("revision_id", revision_id)
        return self

    def page_token(self, page_token: str) -> "GetChatAnnouncementBlockChildrenRequestBuilder":
        self._get_chat_announcement_block_children_request.page_token = page_token
        self._get_chat_announcement_block_children_request.add_query("page_token", page_token)
        return self

    def page_size(self, page_size: int) -> "GetChatAnnouncementBlockChildrenRequestBuilder":
        self._get_chat_announcement_block_children_request.page_size = page_size
        self._get_chat_announcement_block_children_request.add_query("page_size", page_size)
        return self

    def user_id_type(self, user_id_type: str) -> "GetChatAnnouncementBlockChildrenRequestBuilder":
        self._get_chat_announcement_block_children_request.user_id_type = user_id_type
        self._get_chat_announcement_block_children_request.add_query("user_id_type", user_id_type)
        return self

    def chat_id(self, chat_id: str) -> "GetChatAnnouncementBlockChildrenRequestBuilder":
        self._get_chat_announcement_block_children_request.chat_id = chat_id
        self._get_chat_announcement_block_children_request.paths["chat_id"] = str(chat_id)
        return self

    def block_id(self, block_id: str) -> "GetChatAnnouncementBlockChildrenRequestBuilder":
        self._get_chat_announcement_block_children_request.block_id = block_id
        self._get_chat_announcement_block_children_request.paths["block_id"] = str(block_id)
        return self

    def build(self) -> GetChatAnnouncementBlockChildrenRequest:
        return self._get_chat_announcement_block_children_request
