# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.batch_update_chat_announcement_block_request import BatchUpdateChatAnnouncementBlockRequest
from ..model.batch_update_chat_announcement_block_response import BatchUpdateChatAnnouncementBlockResponse
from ..model.get_chat_announcement_block_request import GetChatAnnouncementBlockRequest
from ..model.get_chat_announcement_block_response import GetChatAnnouncementBlockResponse
from ..model.list_chat_announcement_block_request import ListChatAnnouncementBlockRequest
from ..model.list_chat_announcement_block_response import ListChatAnnouncementBlockResponse


class ChatAnnouncementBlock(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def batch_update(self, request: BatchUpdateChatAnnouncementBlockRequest,
                     option: Optional[RequestOption] = None) -> BatchUpdateChatAnnouncementBlockResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BatchUpdateChatAnnouncementBlockResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                            BatchUpdateChatAnnouncementBlockResponse)
        response.raw = resp

        return response

    async def abatch_update(self, request: BatchUpdateChatAnnouncementBlockRequest,
                            option: Optional[RequestOption] = None) -> BatchUpdateChatAnnouncementBlockResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: BatchUpdateChatAnnouncementBlockResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                            BatchUpdateChatAnnouncementBlockResponse)
        response.raw = resp

        return response

    def get(self, request: GetChatAnnouncementBlockRequest,
            option: Optional[RequestOption] = None) -> GetChatAnnouncementBlockResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetChatAnnouncementBlockResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                    GetChatAnnouncementBlockResponse)
        response.raw = resp

        return response

    async def aget(self, request: GetChatAnnouncementBlockRequest,
                   option: Optional[RequestOption] = None) -> GetChatAnnouncementBlockResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: GetChatAnnouncementBlockResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                    GetChatAnnouncementBlockResponse)
        response.raw = resp

        return response

    def list(self, request: ListChatAnnouncementBlockRequest,
             option: Optional[RequestOption] = None) -> ListChatAnnouncementBlockResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListChatAnnouncementBlockResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     ListChatAnnouncementBlockResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListChatAnnouncementBlockRequest,
                    option: Optional[RequestOption] = None) -> ListChatAnnouncementBlockResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListChatAnnouncementBlockResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     ListChatAnnouncementBlockResponse)
        response.raw = resp

        return response
