# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.batch_delete_chat_announcement_block_children_request import \
    BatchDeleteChatAnnouncementBlockChildrenRequest
from ..model.batch_delete_chat_announcement_block_children_response import \
    BatchDeleteChatAnnouncementBlockChildrenResponse
from ..model.create_chat_announcement_block_children_request import CreateChatAnnouncementBlockChildrenRequest
from ..model.create_chat_announcement_block_children_response import CreateChatAnnouncementBlockChildrenResponse
from ..model.get_chat_announcement_block_children_request import GetChatAnnouncementBlockChildrenRequest
from ..model.get_chat_announcement_block_children_response import GetChatAnnouncementBlockChildrenResponse


class ChatAnnouncementBlockChildren(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def batch_delete(self, request: BatchDeleteChatAnnouncementBlockChildrenRequest,
                     option: Optional[RequestOption] = None) -> BatchDeleteChatAnnouncementBlockChildrenResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BatchDeleteChatAnnouncementBlockChildrenResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                                    BatchDeleteChatAnnouncementBlockChildrenResponse)
        response.raw = resp

        return response

    async def abatch_delete(self, request: BatchDeleteChatAnnouncementBlockChildrenRequest,
                            option: Optional[RequestOption] = None) -> BatchDeleteChatAnnouncementBlockChildrenResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: BatchDeleteChatAnnouncementBlockChildrenResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                                    BatchDeleteChatAnnouncementBlockChildrenResponse)
        response.raw = resp

        return response

    def create(self, request: CreateChatAnnouncementBlockChildrenRequest,
               option: Optional[RequestOption] = None) -> CreateChatAnnouncementBlockChildrenResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateChatAnnouncementBlockChildrenResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                               CreateChatAnnouncementBlockChildrenResponse)
        response.raw = resp

        return response

    async def acreate(self, request: CreateChatAnnouncementBlockChildrenRequest,
                      option: Optional[RequestOption] = None) -> CreateChatAnnouncementBlockChildrenResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: CreateChatAnnouncementBlockChildrenResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                               CreateChatAnnouncementBlockChildrenResponse)
        response.raw = resp

        return response

    def get(self, request: GetChatAnnouncementBlockChildrenRequest,
            option: Optional[RequestOption] = None) -> GetChatAnnouncementBlockChildrenResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetChatAnnouncementBlockChildrenResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                            GetChatAnnouncementBlockChildrenResponse)
        response.raw = resp

        return response

    async def aget(self, request: GetChatAnnouncementBlockChildrenRequest,
                   option: Optional[RequestOption] = None) -> GetChatAnnouncementBlockChildrenResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: GetChatAnnouncementBlockChildrenResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                            GetChatAnnouncementBlockChildrenResponse)
        response.raw = resp

        return response
