# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .batch_query_agency_request_body import BatchQueryAgencyRequestBody


class BatchQueryAgencyRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.page_token: Optional[str] = None
        self.page_size: Optional[int] = None
        self.request_body: Optional[BatchQueryAgencyRequestBody] = None

    @staticmethod
    def builder() -> "BatchQueryAgencyRequestBuilder":
        return BatchQueryAgencyRequestBuilder()


class BatchQueryAgencyRequestBuilder(object):

    def __init__(self) -> None:
        batch_query_agency_request = BatchQueryAgencyRequest()
        batch_query_agency_request.http_method = HttpMethod.POST
        batch_query_agency_request.uri = "/open-apis/hire/v1/agencies/batch_query"
        batch_query_agency_request.token_types = {AccessTokenType.TENANT}
        self._batch_query_agency_request: BatchQueryAgencyRequest = batch_query_agency_request

    def user_id_type(self, user_id_type: str) -> "BatchQueryAgencyRequestBuilder":
        self._batch_query_agency_request.user_id_type = user_id_type
        self._batch_query_agency_request.add_query("user_id_type", user_id_type)
        return self

    def page_token(self, page_token: str) -> "BatchQueryAgencyRequestBuilder":
        self._batch_query_agency_request.page_token = page_token
        self._batch_query_agency_request.add_query("page_token", page_token)
        return self

    def page_size(self, page_size: int) -> "BatchQueryAgencyRequestBuilder":
        self._batch_query_agency_request.page_size = page_size
        self._batch_query_agency_request.add_query("page_size", page_size)
        return self

    def request_body(self, request_body: BatchQueryAgencyRequestBody) -> "BatchQueryAgencyRequestBuilder":
        self._batch_query_agency_request.request_body = request_body
        self._batch_query_agency_request.body = request_body
        return self

    def build(self) -> BatchQueryAgencyRequest:
        return self._batch_query_agency_request
