# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .batch_query_external_background_check_request_body import BatchQueryExternalBackgroundCheckRequestBody


class BatchQueryExternalBackgroundCheckRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.external_application_id: Optional[str] = None
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.request_body: Optional[BatchQueryExternalBackgroundCheckRequestBody] = None

    @staticmethod
    def builder() -> "BatchQueryExternalBackgroundCheckRequestBuilder":
        return BatchQueryExternalBackgroundCheckRequestBuilder()


class BatchQueryExternalBackgroundCheckRequestBuilder(object):

    def __init__(self) -> None:
        batch_query_external_background_check_request = BatchQueryExternalBackgroundCheckRequest()
        batch_query_external_background_check_request.http_method = HttpMethod.POST
        batch_query_external_background_check_request.uri = "/open-apis/hire/v1/external_background_checks/batch_query"
        batch_query_external_background_check_request.token_types = {AccessTokenType.TENANT}
        self._batch_query_external_background_check_request: BatchQueryExternalBackgroundCheckRequest = batch_query_external_background_check_request

    def external_application_id(self,
                                external_application_id: str) -> "BatchQueryExternalBackgroundCheckRequestBuilder":
        self._batch_query_external_background_check_request.external_application_id = external_application_id
        self._batch_query_external_background_check_request.add_query("external_application_id",
                                                                      external_application_id)
        return self

    def page_size(self, page_size: int) -> "BatchQueryExternalBackgroundCheckRequestBuilder":
        self._batch_query_external_background_check_request.page_size = page_size
        self._batch_query_external_background_check_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "BatchQueryExternalBackgroundCheckRequestBuilder":
        self._batch_query_external_background_check_request.page_token = page_token
        self._batch_query_external_background_check_request.add_query("page_token", page_token)
        return self

    def request_body(self,
                     request_body: BatchQueryExternalBackgroundCheckRequestBody) -> "BatchQueryExternalBackgroundCheckRequestBuilder":
        self._batch_query_external_background_check_request.request_body = request_body
        self._batch_query_external_background_check_request.body = request_body
        return self

    def build(self) -> BatchQueryExternalBackgroundCheckRequest:
        return self._batch_query_external_background_check_request
