# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class DeleteExternalInterviewRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.external_interview_id: Optional[str] = None

    @staticmethod
    def builder() -> "DeleteExternalInterviewRequestBuilder":
        return DeleteExternalInterviewRequestBuilder()


class DeleteExternalInterviewRequestBuilder(object):

    def __init__(self) -> None:
        delete_external_interview_request = DeleteExternalInterviewRequest()
        delete_external_interview_request.http_method = HttpMethod.DELETE
        delete_external_interview_request.uri = "/open-apis/hire/v1/external_interviews/:external_interview_id"
        delete_external_interview_request.token_types = {AccessTokenType.TENANT}
        self._delete_external_interview_request: DeleteExternalInterviewRequest = delete_external_interview_request

    def external_interview_id(self, external_interview_id: str) -> "DeleteExternalInterviewRequestBuilder":
        self._delete_external_interview_request.external_interview_id = external_interview_id
        self._delete_external_interview_request.paths["external_interview_id"] = str(external_interview_id)
        return self

    def build(self) -> DeleteExternalInterviewRequest:
        return self._delete_external_interview_request
