# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class DeleteExternalOfferRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.external_offer_id: Optional[str] = None

    @staticmethod
    def builder() -> "DeleteExternalOfferRequestBuilder":
        return DeleteExternalOfferRequestBuilder()


class DeleteExternalOfferRequestBuilder(object):

    def __init__(self) -> None:
        delete_external_offer_request = DeleteExternalOfferRequest()
        delete_external_offer_request.http_method = HttpMethod.DELETE
        delete_external_offer_request.uri = "/open-apis/hire/v1/external_offers/:external_offer_id"
        delete_external_offer_request.token_types = {AccessTokenType.TENANT}
        self._delete_external_offer_request: DeleteExternalOfferRequest = delete_external_offer_request

    def external_offer_id(self, external_offer_id: str) -> "DeleteExternalOfferRequestBuilder":
        self._delete_external_offer_request.external_offer_id = external_offer_id
        self._delete_external_offer_request.paths["external_offer_id"] = str(external_offer_id)
        return self

    def build(self) -> DeleteExternalOfferRequest:
        return self._delete_external_offer_request
