# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .tag_talent_request_body import TagTalentRequestBody


class TagTalentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.talent_id: Optional[str] = None
        self.request_body: Optional[TagTalentRequestBody] = None

    @staticmethod
    def builder() -> "TagTalentRequestBuilder":
        return TagTalentRequestBuilder()


class TagTalentRequestBuilder(object):

    def __init__(self) -> None:
        tag_talent_request = TagTalentRequest()
        tag_talent_request.http_method = HttpMethod.POST
        tag_talent_request.uri = "/open-apis/hire/v1/talents/:talent_id/tag"
        tag_talent_request.token_types = {AccessTokenType.TENANT}
        self._tag_talent_request: TagTalentRequest = tag_talent_request

    def talent_id(self, talent_id: str) -> "TagTalentRequestBuilder":
        self._tag_talent_request.talent_id = talent_id
        self._tag_talent_request.paths["talent_id"] = str(talent_id)
        return self

    def request_body(self, request_body: TagTalentRequestBody) -> "TagTalentRequestBuilder":
        self._tag_talent_request.request_body = request_body
        self._tag_talent_request.body = request_body
        return self

    def build(self) -> TagTalentRequest:
        return self._tag_talent_request
