# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.batch_query_external_interview_request import BatchQueryExternalInterviewRequest
from ..model.batch_query_external_interview_response import BatchQueryExternalInterviewResponse
from ..model.create_external_interview_request import CreateExternalInterviewRequest
from ..model.create_external_interview_response import CreateExternalInterviewResponse
from ..model.delete_external_interview_request import DeleteExternalInterviewRequest
from ..model.delete_external_interview_response import DeleteExternalInterviewResponse
from ..model.update_external_interview_request import UpdateExternalInterviewRequest
from ..model.update_external_interview_response import UpdateExternalInterviewResponse


class ExternalInterview(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def batch_query(self, request: BatchQueryExternalInterviewRequest,
                    option: Optional[RequestOption] = None) -> BatchQueryExternalInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BatchQueryExternalInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       BatchQueryExternalInterviewResponse)
        response.raw = resp

        return response

    async def abatch_query(self, request: BatchQueryExternalInterviewRequest,
                           option: Optional[RequestOption] = None) -> BatchQueryExternalInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: BatchQueryExternalInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       BatchQueryExternalInterviewResponse)
        response.raw = resp

        return response

    def create(self, request: CreateExternalInterviewRequest,
               option: Optional[RequestOption] = None) -> CreateExternalInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateExternalInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   CreateExternalInterviewResponse)
        response.raw = resp

        return response

    async def acreate(self, request: CreateExternalInterviewRequest,
                      option: Optional[RequestOption] = None) -> CreateExternalInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: CreateExternalInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   CreateExternalInterviewResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteExternalInterviewRequest,
               option: Optional[RequestOption] = None) -> DeleteExternalInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteExternalInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   DeleteExternalInterviewResponse)
        response.raw = resp

        return response

    async def adelete(self, request: DeleteExternalInterviewRequest,
                      option: Optional[RequestOption] = None) -> DeleteExternalInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: DeleteExternalInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   DeleteExternalInterviewResponse)
        response.raw = resp

        return response

    def update(self, request: UpdateExternalInterviewRequest,
               option: Optional[RequestOption] = None) -> UpdateExternalInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UpdateExternalInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   UpdateExternalInterviewResponse)
        response.raw = resp

        return response

    async def aupdate(self, request: UpdateExternalInterviewRequest,
                      option: Optional[RequestOption] = None) -> UpdateExternalInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: UpdateExternalInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   UpdateExternalInterviewResponse)
        response.raw = resp

        return response
