# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.batch_query_external_offer_request import BatchQueryExternalOfferRequest
from ..model.batch_query_external_offer_response import BatchQueryExternalOfferResponse
from ..model.create_external_offer_request import CreateExternalOfferRequest
from ..model.create_external_offer_response import CreateExternalOfferResponse
from ..model.delete_external_offer_request import DeleteExternalOfferRequest
from ..model.delete_external_offer_response import DeleteExternalOfferResponse
from ..model.update_external_offer_request import UpdateExternalOfferRequest
from ..model.update_external_offer_response import UpdateExternalOfferResponse


class ExternalOffer(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def batch_query(self, request: BatchQueryExternalOfferRequest,
                    option: Optional[RequestOption] = None) -> BatchQueryExternalOfferResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BatchQueryExternalOfferResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   BatchQueryExternalOfferResponse)
        response.raw = resp

        return response

    async def abatch_query(self, request: BatchQueryExternalOfferRequest,
                           option: Optional[RequestOption] = None) -> BatchQueryExternalOfferResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: BatchQueryExternalOfferResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   BatchQueryExternalOfferResponse)
        response.raw = resp

        return response

    def create(self, request: CreateExternalOfferRequest,
               option: Optional[RequestOption] = None) -> CreateExternalOfferResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateExternalOfferResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateExternalOfferResponse)
        response.raw = resp

        return response

    async def acreate(self, request: CreateExternalOfferRequest,
                      option: Optional[RequestOption] = None) -> CreateExternalOfferResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: CreateExternalOfferResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateExternalOfferResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteExternalOfferRequest,
               option: Optional[RequestOption] = None) -> DeleteExternalOfferResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteExternalOfferResponse = JSON.unmarshal(str(resp.content, UTF_8), DeleteExternalOfferResponse)
        response.raw = resp

        return response

    async def adelete(self, request: DeleteExternalOfferRequest,
                      option: Optional[RequestOption] = None) -> DeleteExternalOfferResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: DeleteExternalOfferResponse = JSON.unmarshal(str(resp.content, UTF_8), DeleteExternalOfferResponse)
        response.raw = resp

        return response

    def update(self, request: UpdateExternalOfferRequest,
               option: Optional[RequestOption] = None) -> UpdateExternalOfferResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UpdateExternalOfferResponse = JSON.unmarshal(str(resp.content, UTF_8), UpdateExternalOfferResponse)
        response.raw = resp

        return response

    async def aupdate(self, request: UpdateExternalOfferRequest,
                      option: Optional[RequestOption] = None) -> UpdateExternalOfferResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: UpdateExternalOfferResponse = JSON.unmarshal(str(resp.content, UTF_8), UpdateExternalOfferResponse)
        response.raw = resp

        return response
